; Aline "Attribute-only"
; by Hikaru/Intense in 2016
; SjASMPlus syntax
; Public Domain


; SyncBorder
;
; Delays program execution until the lower border.
; Should be called before a call to Aline.
; Unnecessary if the main loop of your program
; is guaranteed to always finish at the lower border.
SyncBorder
	ld c,7
.lp1
	ld b,c
.lp2
	in a,(#FF)
	inc a
	jr nz,.lp1
	djnz .lp2
	ret


; Aline
;
; Delays execution until a certain T state in the frame (4T precision).
; This version is for unofficial "attribute-only" floating bus mods.
; Should be run during border time.
Aline
	ld hl,#5800
	ld bc,#2004
.fill_lp
	ld (hl),b
	inc l
	djnz .fill_lp
.sync_lp
	in a,(#FF)
	dec a
	jp m,.sync_lp
	sub c		;16T
	jr nc,$-1
	rra		;4T
	jp nc,$+4
	nop
	rra		;8T
	ret nc
	xor a
	ret